/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.aop.interceptor.servlet;

import jp.ossc.nimbus.core.*;

/**
 * {@link StreamExchangeInterceptorService}MBeanC^tF[XB<p>
 * 
 * @author M.Takata
 * @see StreamExchangeInterceptorService
 */
public interface StreamExchangeInterceptorServiceMBean
 extends ServletFilterInterceptorServiceMBean{
    
    /**
     * ftHg̗vIuWFNg̃NGXgB<p>
     */
    public static final String DEFAULT_REQUEST_OBJECT_ATTRIBUTE_NAME = StreamExchangeInterceptorService.class.getName().replaceAll("\\.", "_") + "_REQUEST";
    
    /**
     * ftHg̉IuWFNg̃NGXgB<p>
     */
    public static final String DEFAULT_RESPONSE_OBJECT_ATTRIBUTE_NAME = StreamExchangeInterceptorService.class.getName().replaceAll("\\.", "_") + "_RESPONSE";
    
    /**
     * ftHg̗vIuWFNg̃ReLXgL[B<p>
     */
    public static final String DEFAULT_REQUEST_OBJECT_CONTEXT_KEY = StreamExchangeInterceptorService.class.getName().replaceAll("\\.", "_") + "_REQUEST";
    
    /**
     * ftHg̉IuWFNg̃ReLXgL[B<p>
     */
    public static final String DEFAULT_RESPONSE_OBJECT_CONTEXT_KEY = StreamExchangeInterceptorService.class.getName().replaceAll("\\.", "_") + "_RESPONSE";
    
    /**
     * ftHg̃W[ĩ[gXebvB<p>
     */
    public static final String DEFAULT_EXCHANGE_JOURNAL_KEY = "Exchange";
    
    /**
     * ftHg̃W[i̗vXebvB<p>
     */
    public static final String DEFAULT_EXCHANGE_REQ_JOURNAL_KEY = "Request";
    
    /**
     * ftHg̃W[ỉXebvB<p>
     */
    public static final String DEFAULT_EXCHANGE_RES_JOURNAL_KEY = "Response";
    
    /**
     * ftHg̃W[i̗voCgzvfB<p>
     */
    public static final String DEFAULT_REQUEST_BYTES_JOURNAL_KEY = "RequestBytes";
    
    /**
     * ftHg̃W[i̗vIuWFNgvfB<p>
     */
    public static final String DEFAULT_REQUEST_OBJECT_JOURNAL_KEY = "RequestObject";
    
    /**
     * ftHg̃W[ỉoCgzvfB<p>
     */
    public static final String DEFAULT_RESPONSE_BYTES_JOURNAL_KEY = "ResponseBytes";
    
    /**
     * ftHg̃W[ỉIuWFNgvfB<p>
     */
    public static final String DEFAULT_RESPONSE_OBJECT_JOURNAL_KEY = "ResponseObject";
    
    /**
     * ftHg̃W[i̗OvfB<p>
     */
    public static final String DEFAULT_EXCEPTION_JOURNAL_KEY = "Exception";
    
    /**
     * vXg[vIuWFNgɕϊ{@link jp.ossc.nimbus.util.converter.StreamConverter StreamConverter}T[rXݒ肷B<p>
     *
     * @param name StreamConverterT[rX
     */
    public void setRequestStreamConverterServiceName(ServiceName name);
    
    /**
     * vXg[vIuWFNgɕϊ{@link jp.ossc.nimbus.util.converter.StreamConverter StreamConverter}T[rX擾B<p>
     *
     * @return StreamConverterT[rX
     */
    public ServiceName getRequestStreamConverterServiceName();
    
    /**
     * IuWFNgXg[ɕϊ{@link jp.ossc.nimbus.util.converter.StreamConverter StreamConverter}T[rXݒ肷B<p>
     *
     * @param name StreamConverterT[rX
     */
    public void setResponseStreamConverterServiceName(ServiceName name);
    
    /**
     * IuWFNgXg[ɕϊ{@link jp.ossc.nimbus.util.converter.StreamConverter StreamConverter}T[rX擾B<p>
     *
     * @return StreamConverterT[rX
     */
    public ServiceName getResponseStreamConverterServiceName();
    
    /**
     * vIuWFNgyщIuWFNg悹{@link jp.ossc.nimbus.service.context.Context Context}T[rXݒ肷B<p>
     * ̑ݒ肵Ȃꍇ́ANGXĝ݂ɏ悹B<br>
     *
     * @param name ContextT[rX
     */
    public void setThreadContextServiceName(ServiceName name);
    
    /**
     * vIuWFNgyщIuWFNg悹{@link jp.ossc.nimbus.service.context.Context Context}T[rX擾B<p>
     *
     * @return ContextT[rX
     */
    public ServiceName getThreadContextServiceName();
    
    /**
     * W[io͂{@link jp.ossc.nimbus.service.journal.Journal Journal}T[rXݒ肷B<p>
     *
     * @param name JournalT[rX
     */
    public void setJournalServiceName(ServiceName name);
    
    /**
     * W[io͂{@link jp.ossc.nimbus.service.journal.Journal Journal}T[rX擾B<p>
     *
     * @return JournalT[rX
     */
    public ServiceName getJournalServiceName();
    
    /**
     * W[ĩ[gXebvҏW{@link jp.ossc.nimbus.service.journal.JournalEditor JournalEditor}{@link jp.ossc.nimbus.service.journal.editorfinder.EditorFinder EditorFinder}T[rXݒ肷B<p>
     *
     * @param name EditorFinderT[rX
     */
    public void setExchangeEditorFinderServiceName(ServiceName name);
    
    /**
     * W[ĩ[gXebvҏW{@link jp.ossc.nimbus.service.journal.JournalEditor JournalEditor}{@link jp.ossc.nimbus.service.journal.editorfinder.EditorFinder EditorFinder}T[rX擾B<p>
     *
     * @return EditorFinderT[rX
     */
    public ServiceName getExchangeEditorFinderServiceName();
    
    /**
     * W[i̗vXebvҏW{@link jp.ossc.nimbus.service.journal.JournalEditor JournalEditor}{@link jp.ossc.nimbus.service.journal.editorfinder.EditorFinder EditorFinder}T[rXݒ肷B<p>
     *
     * @param name EditorFinderT[rX
     */
    public void setExchangeRequestEditorFinderServiceName(ServiceName name);
    
    /**
     * W[i̗vXebvҏW{@link jp.ossc.nimbus.service.journal.JournalEditor JournalEditor}{@link jp.ossc.nimbus.service.journal.editorfinder.EditorFinder EditorFinder}T[rX擾B<p>
     *
     * @return EditorFinderT[rX
     */
    public ServiceName getExchangeRequestEditorFinderServiceName();
    
    /**
     * W[ỉXebvҏW{@link jp.ossc.nimbus.service.journal.JournalEditor JournalEditor}{@link jp.ossc.nimbus.service.journal.editorfinder.EditorFinder EditorFinder}T[rXݒ肷B<p>
     *
     * @param name EditorFinderT[rX
     */
    public void setExchangeResponseEditorFinderServiceName(ServiceName name);
    
    /**
     * W[ỉXebvҏW{@link jp.ossc.nimbus.service.journal.JournalEditor JournalEditor}{@link jp.ossc.nimbus.service.journal.editorfinder.EditorFinder EditorFinder}T[rX擾B<p>
     *
     * @return EditorFinderT[rX
     */
    public ServiceName getExchangeResponseEditorFinderServiceName();
    
    /**
     * W[ĩ[gXebṽL[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_EXCHANGE_JOURNAL_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_EXCHANGE_JOURNAL_KEY
     */
    public void setExchangeJournalKey(String key);
    
    /**
     * W[ĩ[gXebṽL[擾B<p>
     *
     * @return L[
     */
    public String getExchangeJournalKey();
    
    /**
     * W[i̗vXebṽL[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_EXCHANGE_REQ_JOURNAL_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_EXCHANGE_REQ_JOURNAL_KEY
     */
    public void setExchangeRequestJournalKey(String key);
    
    /**
     * W[i̗vXebṽL[擾B<p>
     *
     * @return L[
     */
    public String getExchangeRequestJournalKey();
    
    /**
     * W[ỉXebṽL[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_EXCHANGE_RES_JOURNAL_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_EXCHANGE_RES_JOURNAL_KEY
     */
    public void setExchangeResponseJournalKey(String key);
    
    /**
     * W[ỉXebṽL[擾B<p>
     *
     * @return L[
     */
    public String getExchangeResponseJournalKey();
    
    /**
     * W[i̗voCgz̃L[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_REQUEST_BYTES_JOURNAL_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_REQUEST_BYTES_JOURNAL_KEY
     */
    public void setRequestBytesJournalKey(String key);
    
    /**
     * W[i̗voCgz̃L[擾B<p>
     *
     * @return L[
     */
    public String getRequestBytesJournalKey();
    
    /**
     * W[i̗vIuWFNg̃L[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_REQUEST_OBJECT_JOURNAL_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_REQUEST_OBJECT_JOURNAL_KEY
     */
    public void setRequestObjectJournalKey(String key);
    
    /**
     * W[i̗vIuWFNg̃L[擾B<p>
     *
     * @return L[
     */
    public String getRequestObjectJournalKey();
    
    /**
     * W[ỉoCgz̃L[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_RESPONSE_BYTES_JOURNAL_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_RESPONSE_BYTES_JOURNAL_KEY
     */
    public void setResponseBytesJournalKey(String key);
    
    /**
     * W[ỉoCgz̃L[擾B<p>
     *
     * @return L[
     */
    public String getResponseBytesJournalKey();
    
    /**
     * W[ỉIuWFNg̃L[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_RESPONSE_OBJECT_JOURNAL_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_RESPONSE_OBJECT_JOURNAL_KEY
     */
    public void setResponseObjectJournalKey(String key);
    
    /**
     * W[ỉIuWFNg̃L[擾B<p>
     *
     * @return L[
     */
    public String getResponseObjectJournalKey();
    
    /**
     * W[i̗ÕL[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_EXCEPTION_JOURNAL_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_EXCEPTION_JOURNAL_KEY
     */
    public void setExceptionJournalKey(String key);
    
    /**
     * W[i̗ÕL[擾B<p>
     *
     * @return L[
     */
    public String getExceptionJournalKey();
    
    /**
     * HTTPX|X̃Reg^Cvݒ肷B<p>
     *
     * @param type Reg^Cv
     */
    public void setResponseContentType(String type);
    
    /**
     * HTTPX|X̃Reg^Cv擾B<p>
     *
     * @return Reg^Cv
     */
    public String getResponseContentType();
    
    /**
     * vIuWFNgNGXgɐݒ肷鎞Ɏgp鑮ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_REQUEST_OBJECT_ATTRIBUTE_NAME}B<br>
     *
     * @param name 
     * @see #DEFAULT_REQUEST_OBJECT_ATTRIBUTE_NAME
     */
    public void setRequestObjectAttributeName(String name);
    
    /**
     * vIuWFNgNGXgɐݒ肷鎞Ɏgp鑮擾B<p>
     *
     * @return 
     */
    public String getRequestObjectAttributeName();
    
    /**
     * IuWFNgNGXgɐݒ肷鎞Ɏgp鑮ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_RESPONSE_OBJECT_ATTRIBUTE_NAME}B<br>
     *
     * @param name 
     * @see #DEFAULT_RESPONSE_OBJECT_ATTRIBUTE_NAME
     */
    public void setResponseObjectAttributeName(String name);
    
    /**
     * IuWFNgNGXgɐݒ肷鎞Ɏgp鑮擾B<p>
     *
     * @return 
     */
    public String getResponseObjectAttributeName();
    
    /**
     * vIuWFNgReLXgɐݒ肷鎞ɎgpL[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_REQUEST_OBJECT_CONTEXT_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_REQUEST_OBJECT_CONTEXT_KEY
     */
    public void setRequestObjectContextKey(String key);
    
    /**
     * vIuWFNgReLXgɐݒ肷鎞ɎgpL[擾B<p>
     *
     * @return L[
     */
    public String getRequestObjectContextKey();
    
    /**
     * IuWFNgReLXgɐݒ肷鎞ɎgpL[ݒ肷B<p>
     * ftHgĺA{@link #DEFAULT_RESPONSE_OBJECT_CONTEXT_KEY}B<br>
     *
     * @param key L[
     * @see #DEFAULT_RESPONSE_OBJECT_CONTEXT_KEY
     */
    public void setResponseObjectContextKey(String key);
    
    /**
     * IuWFNgReLXgɐݒ肷鎞ɎgpL[擾B<p>
     *
     * @return L[
     */
    public String getResponseObjectContextKey();
    
    /**
     * NGXgXg[̉𓀂sǂݒ肷B<p>
     * ftHǵAtrueB<br>
     *
     * @param isInflate 𓀂sꍇ́Atrue
     */
    public void setRequestStreamInflate(boolean isInflate);
    
    /**
     * NGXgXg[̉𓀂sǂ𔻒肷B<p>
     *
     * @return truȅꍇA𓀂s
     */
    public boolean isRequestStreamInflate();
}