/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.cache;

import jp.ossc.nimbus.core.ServiceBaseMBean;

/**
 * {@link TimeExpierOverflowValidatorService}MBeanC^tF[X<p>
 * 
 * @author M.Takata
 * @see TimeExpierOverflowValidatorService
 */
public interface TimeExpierOverflowValidatorServiceMBean
 extends ServiceBaseMBean{
    
    /**
     * LbV̗L[ms]ݒ肷B<p>
     * LȒl͈̔͂́A0ȏBftHg0ŁAȂB<br>
     *
     * @param millis LbV̗L[ms]
     */
    public void setExpierTerm(long millis) throws IllegalArgumentException;
    
    /**
     * LbV̗L[ms]擾B<p>
     *
     * @return LbV̗L[ms]
     */
    public long getExpierTerm();
    
    /**
     * LbV̗L؂[ms]ݒ肷B<p>
     * 
     * @param millis LbV̗L؂[ms]
     * @throws IllegalArgumentException
     */
    public void setPeriod(long millis) throws IllegalArgumentException;
    
    /**
     * LbV̗L؂[ms]擾B<p>
     * 
     * @return LbV̗L؂[ms]
     */
    public long getPeriod();

    /**
     * LbV؂邽߂ɕێĂB<p>
     */
    public void reset();
    
    /**
     * ӂꌟ؂sB<p>
     *
     * @return ӂꌟ؂sʂӂꂪꍇAӂꐔԂBӂȂꍇ́A0Ԃ
     */
    public int validate();
    
    /**
     * ӂꌟؑΏۂɂȂĂLbV擾B<p>
     *
     * @return LbV
     */
    public int size();
}
