/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.graph;

import jp.ossc.nimbus.core.ServiceBaseMBean;
import jp.ossc.nimbus.service.sql.ConnectionFactory;

/**
 * {@link DatabaseDatasetFactoryService}MBeanC^tF[XB<p>
 *
 * @author M.Takata
 */
public interface DatabaseDatasetFactoryServiceMBean
    extends ServiceBaseMBean {

    /**
     * RlNVt@Ngݒ肷B<p>
     *
     * @param connFactory RlNVt@Ng
     */
    public void setConnectionFactory(ConnectionFactory connFactory);

    /**
     * RlNVt@Ng擾B<p>
     *
     * @return RlNVt@Ng
     */
    public ConnectionFactory getConnectionFactory();

    /**
     * f[^ZbgۂɕKvȃf[^擾SQLzݒ肷B<p>
     * [V[Y=SQL]ƂŐݒ肳Ă܂B
     *
     * @param sqls [V[Y=SQL]̔z
     */
    public void setSqls(String[] sqls);

    /**
     * f[^ZbgۂɕKvȃf[^擾SQLzݒ肷B<p>
     * [V[Y=SQL]ƂŐݒ肳Ă܂B
     *
     * @return [V[Y=SQL]̔z
     */
    public String[] getSqls();

    /**
     * f[^ZbgǉB<p>
     * 
     * @param dsCondition f[^Zbg
     */
    public void addDatasetCondition(DatasetCondition dsCondition);

    /**
     * f[^Zbg̔z擾B<p>
     * 
     * @return f[^Zbg̔z
     */
    public DatasetCondition[] getDatasetConditions();

    /**
     * tFb`TCYݒ肷B<p>
     * 
     * @param size tFb`TCY
     */
    public void setFetchSize(int size);
    
    /**
     * tFb`TCY擾B<p>
     * 
     * @return tFb`TCY
     */
    public int getFetchSize();

}
