/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.http.httpclient;

import java.io.*;
import java.util.*;

import org.apache.commons.httpclient.*;

/**
 * Jakarta HttpClientgHTTP CONNECTNGXgB<p>
 *
 * @author M.Takata
 */
public class ConnectHttpRequestImpl extends HttpRequestImpl{
    
    private HostConfiguration hostConfig = null;
    
    public void setHostConfiguration(HostConfiguration config){
        hostConfig = config;
    }
    
    /**
     * {@link ConnectMethod}𐶐B<p>
     *
     * @return ConnectMethod
     * @exception Exception ConnectMethod̐Ɏsꍇ
     */
    protected HttpMethodBase instanciateHttpMethod() throws Exception{
        return new ConnectMethod(hostConfig){
            public URI getURI() throws URIException {
                String charset = getParams().getUriCharset();
                return new URI(hostConfig.getProtocol().getScheme() + "://" + getPath(), true, charset);
            }
        };
    }
    
    /**
     * T|[gȂB<p>
     *
     * @param method HTTP\bh
     * @param params NGXgp[^
     * @exception Exception UnsupportedOperationException𓊂
     */
    protected void initParameter(
        HttpMethodBase method,
        Map<String, String[]> params
    ) throws Exception{
        throw new UnsupportedOperationException();
    }
    
    /**
     * T|[gȂB<p>
     *
     * @param method HTTP\bh
     * @param is ̓Xg[
     * @exception Exception UnsupportedOperationException𓊂
     */
    protected void initInputStream(
        HttpMethodBase method,
        InputStream is
    ) throws Exception{
        throw new UnsupportedOperationException();
    }
}