/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.jms;

import javax.jms.*;

/**
 * JMSZbVt@NgB<p>
 * 
 * @author M.Takata
 */
public interface JMSSessionFactory{
    
    /**
     * ̃t@NgێĂConnection擾B<p>
     * getSession\bhŁASession𐶐ۂɁAConnectionw肵Ȃꍇ́AConnectiongpB<br>
     *
     * @return ̃t@NgێĂConnectionBConnectionێĂȂꍇnullB
     */
    public Connection getConnection();
    
    /**
     * ̃t@NgConnection̎擾Ɏgp{@link JMSConnectionFactory}T[rX擾B<p>
     *
     * @return {@link JMSConnectionFactory}T[rX
     */
    public JMSConnectionFactory getConnectionFactory();
    
    /**
     * JMSZbV擾B<p>
     * {@link #getConnection()}Ŏ擾ConnectionA{@link Connection#createSession(boolean, int)}\bhŐB<br>
     * getConnection()nullԂꍇ́AJMSSessionCreateExceptionthrowB<br>
     * ́AT[rX̎Ɉˑ邪Aɐݒ肪ȂfalseASession.AUTO_ACKNOWLEDGEB<br>
     *
     * @return JMSZbV
     * @exception JMSSessionCreateException JMSZbV̐Ɏsꍇ
     */
    public Session getSession() throws JMSSessionCreateException;
    
    /**
     * JMSZbV擾B<p>
     * {@link #getConnection()}Ŏ擾ConnectionA{@link Connection#createSession(boolean, int)}\bhŐB<br>
     * getConnection()nullԂꍇ́AJMSSessionCreateExceptionthrowB<br>
     *
     * @param transactionMode gUNVT|[gꍇAtrue
     * @param ackMode MessageConsumerJMSNCAgbZ[WMACK̕Ԃ̃[h
     * @return JMSZbV
     * @exception JMSSessionCreateException JMSZbV̐Ɏsꍇ
     */
    public Session getSession(
        boolean transactionMode,
        int ackMode
    ) throws JMSSessionCreateException;
    
    /**
     * JMSZbV擾B<p>
     * Ŏw肳ꂽConnectionA{@link Connection#createSession(boolean, int)}\bhŐB<br>
     * ́AT[rX̎Ɉˑ邪Aɐݒ肪ȂfalseASession.AUTO_ACKNOWLEDGEB<br>
     *
     * @param con Connection
     * @return JMSZbV
     * @exception JMSSessionCreateException JMSZbV̐Ɏsꍇ
     */
    public Session getSession(Connection con) throws JMSSessionCreateException;
    
    /**
     * JMSZbV擾B<p>
     * Ŏw肳ꂽConnectionA{@link Connection#createSession(boolean, int)}\bhŐB<br>
     *
     * @param con Connection
     * @param transactionMode gUNVT|[gꍇAtrue
     * @param ackMode MessageConsumerJMSNCAgbZ[WMACK̕Ԃ̃[h
     * @return JMSZbV
     * @exception JMSSessionCreateException JMSZbV̐Ɏsꍇ
     */
    public Session getSession(
        Connection con,
        boolean transactionMode,
        int ackMode
    ) throws JMSSessionCreateException;
}
