/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.journal.editor;

import jp.ossc.nimbus.core.ServiceBase;
import jp.ossc.nimbus.service.journal.JournalEditor;
import jp.ossc.nimbus.service.journal.EditorFinder;

/**
 * Class𕶎ɕҏWJournalEditorT[rXB<p>
 * 
 * @author M.Takata
 */
public class ClassJournalEditorService extends ServiceBase
 implements JournalEditor, ClassJournalEditorServiceMBean{
    
    private static final long serialVersionUID = -1909937107403583674L;
    
    protected boolean isShortClassName = true;
    
    @Override
    public void setShortClassName(boolean isShort){
        isShortClassName = isShort;
    }
    
    @Override
    public boolean isShortClassName(){
        return isShortClassName;
    }
    
    @Override
    public Object toObject(EditorFinder finder, String key, Object value){
        final Class<?> clazz = (Class<?>)value;
        String className = clazz.getName();
        if(isShortClassName()){
            className = getShortClassName(className);
        }
        return className;
    }
    
    protected String getShortClassName(Class<?> clazz){
        return getShortClassName(clazz.getName());
    }
    
    protected String getShortClassName(String longName){
        String shortClassName = longName;
        final int index = shortClassName.lastIndexOf('.');
        if(index != -1){
            shortClassName = shortClassName.substring(index + 1);
        }
        return shortClassName;
    }
}