/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.scheduler;

import jp.ossc.nimbus.core.*;

/**
 * {@link BeanFlowScheduleExecutorService}MBeanC^tF[XB<p>
 * 
 * @author M.Takata
 */
public interface BeanFlowScheduleExecutorServiceMBean extends AbstractScheduleExecutorServiceMBean{
    
    /**
     * ftHg̃XPW[sʁB<p>
     */
    public static final String DEFAULT_EXECUTOR_TYPE = "BEANFLOW";
    
    /**
     * XPW[ꎞ~ꍇ̃ObZ[WIDB<p>
     */
    public static final String MSG_ID_PAUSE = "BFSE_00001";
    
    /**
     * XPW[ĊJꍇ̃ObZ[WIDB<p>
     */
    public static final String MSG_ID_RESUME = "BFSE_00002";
    
    /**
     * {@link jp.ossc.nimbus.service.beanflow.BeanFlowFactory BeanFlowFactory}T[rX̃T[rXݒ肷B<p>
     *
     * @param name BeanFlowFactoryT[rX̃T[rX
     */
    public void setBeanFlowFactoryServiceName(ServiceName name);
    
    /**
     * {@link jp.ossc.nimbus.service.beanflow.BeanFlowFactory BeanFlowFactory}T[rX̃T[rX擾B<p>
     *
     * @return BeanFlowFactoryT[rX̃T[rX
     */
    public ServiceName getBeanFlowFactoryServiceName();
    
    /**
     * XPW[̐Ԃ̕ύXۂɌǂmFԊu[ms]ݒ肷B<p>
     * ftHǵA500[ms]B<br>
     *
     * @param interval Ԋu[ms]
     */
    public void setControlStateChangingWaitInterval(long interval);
    
    /**
     * XPW[̐Ԃ̕ύXۂɌǂmFԊu[ms]擾B<p>
     *
     * @return Ԋu[ms]
     */
    public long getControlStateChangingWaitInterval();
    
    /**
     * XPW[̐Ԃ̕ύXۂɌǂmF҂鎞[ms]ݒ肷B<p>
     * ftHǵA-1Ŗ҂B<br>
     *
     * @param timeout ^CAEg[ms]
     */
    public void setControlStateChangingWaitTimeout(long timeout);
    
    /**
     * XPW[̐Ԃ̕ύXۂɌǂmF҂鎞[ms]擾B<p>
     *
     * @return ^CAEg[ms]
     */
    public long getControlStateChangingWaitTimeout();
}
