/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.scheduler;

import java.util.*;

import jp.ossc.nimbus.core.*;

/**
 * {@link DefaultScheduleManagerService}MBeanC^tF[XB<p>
 * 
 * @author M.Takata
 */
public interface DefaultScheduleManagerServiceMBean extends ServiceBaseMBean{
    
    /**
     * XPW[̃^CI[o[ĎŃ^CI[o[XPW[𔭌ꍇ̃ObZ[WIDB<p>
     */
    public static final String MSG_ID_TIMEOVER_ERROR = "DSM__00003";
    
    /**
     * XPW[}X^Ƃēo^{@link ScheduleMaster}T[rX̃T[rXݒ肷B<p>
     *
     * @param names ScheduleMasterT[rX̃T[rXz
     */
    public void setScheduleMasterServiceNames(ServiceName[] names);
    
    /**
     * XPW[}X^Ƃēo^{@link ScheduleMaster}T[rX̃T[rX擾B<p>
     *
     * @return ScheduleMasterT[rX̃T[rXz
     */
    public ServiceName[] getScheduleMasterServiceNames();
    
    /**
     * XPW[ʂ{@link ScheduleMaker}T[rX̃}bsOݒ肷B<p>
     *
     * @param mapping XPW[ʂScheduleMakerT[rX̃}bsOBXPW[=ScheduleMakerT[rX
     */
    public void setScheduleMakerTypeMapping(Properties mapping);
    
    /**
     * XPW[ʂ{@link ScheduleMaker}T[rX̃}bsO擾B<p>
     *
     * @return XPW[ʂScheduleMakerT[rX̃}bsO
     */
    public Properties getScheduleMakerTypeMapping();
    
    /**
     * ftHg{@link ScheduleMaker}T[rX̃T[rXݒ肷B<p>
     * w肵Ȃꍇ́A{@link DefaultScheduleMakerService}KpB<br>
     *
     * @param name ScheduleMakerT[rX̃T[rX
     */
    public void setDefaultScheduleMakerServiceName(ServiceName name);
    
    /**
     * ftHg{@link ScheduleMaker}T[rX̃T[rX擾B<p>
     *
     * @return ScheduleMakerT[rX̃T[rX
     */
    public ServiceName getDefaultScheduleMakerServiceName();
    
    /**
     * XPW[ID𔭔Ԃ{@link jp.ossc.nimbus.service.sequence.Sequence Sequence}T[rX̃T[rXݒ肷B<p>
     * w肵Ȃꍇ́Alongl̒ʔԂ̔ԂB<br>
     *
     * @param name SequenceT[rX̃T[rX
     */
    public void setSequenceServiceName(ServiceName name);
    
    /**
     * XPW[ID𔭔Ԃ{@link jp.ossc.nimbus.service.sequence.Sequence Sequence}T[rX̃T[rX擾B<p>
     *
     * @return SequenceT[rX̃T[rX
     */
    public ServiceName getSequenceServiceName();
    
    /**
     * T[rX̊JnɃVXetgāAXPW[쐬邩ǂݒ肷B<p>
     *
     * @param isMake 쐬ꍇAtrue
     */
    public void setMakeScheduleOnStart(boolean isMake);
    
    /**
     * T[rX̊JnɃVXetgāAXPW[쐬邩ǂ𔻒肷B<p>
     *
     * @return truȅꍇA쐬
     */
    public boolean isMakeScheduleOnStart();
    
    /**
     * 쐬XPW[ifBNgݒ肷B<p>
     * ݒ肵Ȃꍇ́AiȂB<br>
     *
     * @param dir fBNg
     */
    public void setPersistDir(String dir);
    
    /**
     * 쐬XPW[ifBNg擾B<p>
     *
     * @return fBNg
     */
    public String getPersistDir();
    
    /**
     * őxԂ`FbNԊu[ms]ݒ肷B<p>
     * ftHǵA1bB<br>
     *
     * @param interval Ԋu[ms]
     */
    public void setTimeoverCheckInterval(long interval);
    
    /**
     * őxԂ`FbNԊu[ms]𔻒肷B<p>
     *
     * @return Ԋu[ms]
     */
    public long getTimeoverCheckInterval();
    
    /**
     * w肳ꂽt̃XPW[쐬B<p>
     *
     * @param date t
     * @throws ScheduleMakeException XPW[쐬Ɏsꍇ
     */
    public void makeSchedule(Date date) throws ScheduleMakeException;
    
    /**
     * SẴXPW[B<p>
     *
     * @return XPW[Xg
     * @exception ScheduleManageException XPW[̌Ɏsꍇ
     */
    public List<Schedule> findAllSchedules() throws ScheduleManageException;
    
    /**
     * w肳ꂽXPW[B<p>
     *
     * @param id XPW[ID
     * @return XPW[
     * @exception ScheduleManageException XPW[̌Ɏsꍇ
     */
    public Schedule findSchedule(String id) throws ScheduleManageException;
    
    /**
     * w肳ꂽԂ̃XPW[B<p>
     *
     * @param from Ԃ̊Jn
     * @param to Ԃ̏I
     * @return XPW[Xg
     * @exception ScheduleManageException XPW[̌Ɏsꍇ
     */
    public List<Schedule> findSchedules(Date from, Date to) throws ScheduleManageException;
    
    /**
     * w肳ꂽԂ̃XPW[B<p>
     *
     * @param states XPW[Ԃ̔z
     * @return XPW[Xg
     * @exception ScheduleManageException XPW[̌Ɏsꍇ
     */
    public List<Schedule> findSchedules(int[] states) throws ScheduleManageException;
    
    /**
     * w肳ꂽԁAw肳ꂽԂ̃XPW[B<p>
     *
     * @param from Ԃ̊Jn
     * @param to Ԃ̏I
     * @param states XPW[Ԃ̔z
     * @return XPW[Xg
     * @exception ScheduleManageException XPW[̌Ɏsꍇ
     */
    public List<Schedule> findSchedules(Date from, Date to, int[] states) throws ScheduleManageException;
    
    /**
     * w肳ꂽƎsʂŎs\ȃXPW[B<p>
     *
     * @param date 
     * @param executorTypes sʔz
     * @return XPW[Xg
     * @exception ScheduleManageException XPW[̌Ɏsꍇ
     */
    public List<Schedule> findExecutableSchedules(Date date, String[] executorTypes) throws ScheduleManageException;
    
    /**
     * w肳ꂽsL[ƎsʁAŎs\ȃXPW[B<p>
     *
     * @param date 
     * @param executorTypes sʔz
     * @param executorKey sL[
     * @return XPW[Xg
     * @exception ScheduleManageException XPW[̌Ɏsꍇ
     */
    public List<Schedule> findExecutableSchedules(Date date, String[] executorTypes, String executorKey) throws ScheduleManageException;
    
    /**
     * XPW[o^B<p>
     *
     * @param masterId XPW[}X^ID
     * @param time XPW[
     * @param taskName ^XN
     * @param input ̓f[^
     * @param depends ˑXPW[}X^ID̔z
     * @param executorKey ScheduleExecutor肷L[
     * @param executorType ScheduleExecutor̎
     * @param retryInterval gCԊu[ms]
     * @param retryEndTime gCI
     * @param maxDelayTime őx
     * @exception ScheduleManageException XPW[̓o^Ɏsꍇ
     */
    public void addSchedule(
        String masterId,
        Date time,
        String taskName,
        Object input,
        String[] depends,
        String executorKey,
        String executorType,
        long retryInterval,
        Date retryEndTime,
        long maxDelayTime
    ) throws ScheduleManageException;
    
    /**
     * XPW[ύXB<p>
     *
     * @param id XPW[ID
     * @param time 
     * @return XPW[XVꂽꍇtrue
     * @exception ScheduleManageException XPW[̍XVɎsꍇ
     */
    public boolean reschedule(String id, Date time) throws ScheduleManageException;
    
    /**
     * XPW[폜B<p>
     *
     * @param id XPW[ID
     * @return XPW[폜ꂽꍇtrue
     * @exception ScheduleManageException XPW[̍폜Ɏsꍇ
     */
    public boolean removeSchedule(String id) throws ScheduleManageException;
    
    /**
     * XPW[폜B<p>
     *
     * @param masterId XPW[}X^ID
     * @return XPW[폜ꂽꍇtrue
     * @exception ScheduleManageException XPW[̍폜Ɏsꍇ
     */
    public boolean removeScheduleByMasterId(String masterId) throws ScheduleManageException;
    
    /**
     * w肳ꂽt̃XPW[폜B<p>
     *
     * @param date t
     * @return XPW[폜ꂽꍇtrue
     * @exception ScheduleManageException XPW[̍폜Ɏsꍇ
     */
    public boolean removeSchedule(Date date) throws ScheduleManageException;
    
    /**
     * XPW[s{@link ScheduleExecutor}ݒ肷B<p>
     *
     * @param id XPW[ID
     * @param key ScheduleExecutor肷L[
     */
    public void setExecutorKey(String id, String key) throws ScheduleManageException;
    
    /**
     * w肳ꂽXPW[̏Ԃ擾B<p>
     *
     * @param id XPW[ID
     * @return 
     * @exception ScheduleStateControlException XPW[Ԃ̎擾Ɏsꍇ
     */
    public int getState(String id) throws ScheduleStateControlException;
    
    /**
     * w肳ꂽXPW[̐Ԃ擾B<p>
     *
     * @param id XPW[ID
     * @return 
     * @exception ScheduleStateControlException XPW[Ԃ̎擾Ɏsꍇ
     */
    public int getControlState(String id) throws ScheduleStateControlException;
    
    /**
     * w肳ꂽXPW[̏ԂύXB<p>
     *
     * @param id XPW[ID
     * @param state 
     * @return ԂύXꂽꍇtrue
     * @exception ScheduleStateControlException XPW[Ԃ̕ύXɎsꍇ
     */
    public boolean changeState(String id, int state) throws ScheduleStateControlException;
    
    /**
     * w肳ꂽXPW[̏ԂύXB<p>
     *
     * @param id XPW[ID
     * @param state 
     * @param output s
     * @return ԂύXꂽꍇtrue
     * @exception ScheduleStateControlException XPW[Ԃ̕ύXɎsꍇ
     */
    public boolean changeState(String id, int state, Object output) throws ScheduleStateControlException;
    
    /**
     * w肳ꂽXPW[̐ԂύXB<p>
     *
     * @param id XPW[ID
     * @param state 
     * @return ԂύXꂽꍇtrue
     * @exception ScheduleStateControlException XPW[Ԃ̕ύXɎsꍇ
     */
    public boolean changeControlState(String id, int state) throws ScheduleStateControlException;
}