/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.sequence;

import java.util.List;

import jp.ossc.nimbus.io.CSVReader;

/**
 * PǗNXB<p>
 * e̊JnAIǗăJǧオ葀sB<br>
 * 
 * @author H.Nakano
 */
public class SimpleSequenceVariable
 implements SequenceVariable, java.io.Serializable{
    
    private static final long serialVersionUID = -2852302890121212311L;
    
    public static final String DELIMITER = "," ;
    
    /** Jnl */
    private String startVal;
    /** Il */
    private String endVal;
    /** Jgԍ */
    private String currentVal;
    
    /**
     * RXgN^B<p>
     * JnlAIlp[XăoϐɃZbgČݒlɊJnlZbgB<br>
     * 
     * @param format Jn,I `̕
     */
    public SimpleSequenceVariable(String format){
        this(format, null);
    }
    
    /**
     * RXgN^B<p>
     * JnlAIlp[XăoϐɃZbgB܂Aw肳ꂽݒloϐɃZbgB<br>
     * 
     * @param format Jn,I `̕
     * @param current ݒl
     */
    public SimpleSequenceVariable(String format, String current){
        // formatJnlƏIlɕ
        List<String> csv = CSVReader.toList(
            format,
            null,
            ',',
            '\\',
            '"',
            "",
            null,
            true,
            false,
            true,
            false
        );
        
        // JnlAIlAݒloϐɃZbg
        startVal = csv.get(0);
        endVal = csv.get(1);
        currentVal = current == null ? startVal : current;
    }
    
    // SequenceVariable JavaDoc
    public boolean increment(){
        // ݒlCNgB
        char[] cValtmp = currentVal.toCharArray();
        cValtmp[0]++;
        final String incVal = new String(cValtmp);
        // CNgʂIl𒴂ĂȂ`FbN
        if(incVal.compareTo(endVal) > 0){
            currentVal = startVal;
            return true;
        }else{
            currentVal = incVal;
            return false;
        }
    }
    
    // SequenceVariable JavaDoc
    public void clear(){
        currentVal = startVal;
    }
    
    // SequenceVariable JavaDoc
    public String getCurrent(){
        return currentVal;
    }
}
