/*
 * This software is distributed under following license based on modified BSD
 * style license.
 * ----------------------------------------------------------------------
 * 
 * Copyright 2009 The Nimbus2 Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE NIMBUS PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
 * NO EVENT SHALL THE NIMBUS PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the Nimbus2 Project.
 */
package jp.ossc.nimbus.service.writer;

import java.lang.reflect.*;

/**
 * OLqvfB<p>
 * ݒ肳ꂽOX^bNg[Xtŏo͂LqvfNXłB<br>
 *
 * @author K.Nagai
 */
public class ThrowableSimpleElement extends SimpleElement {
    
    private static final long serialVersionUID = -6342673505293153134L;
    
    private static final String LINE_SEP = System.getProperty("line.separator");
    private static final String TAB = "\t";
    private static final String MSG_TITLE = "Exception occuers :";
    private static final String MSG_CAUSE = "Caused by:";
    private static final String SERVLET_EXCEPTION_NAME = "javax.servlet.ServletException";
    private static final String GET_ROOT_CAUSE_METHOD = "getRootCause";
    private static final String JMS_EXCEPTION_NAME = "javax.jms.JMSException";
    private static final String GET_LINKED_EXCEPTION_METHOD = "getLinkedException";
    
    private boolean isOutputCause = true;
    private boolean isOutputTab = true;
    
    /**
     * ̃CX^X𐶐B<p>
     */
    public ThrowableSimpleElement(){
    }
    
    /**
     * CX^X𐶐B<p>
     *
     * @param value ϊΏۂ̃IuWFNg
     */
    public ThrowableSimpleElement(Object value){
        super(value);
    }
    
    /**
     * CX^X𐶐B<p>
     *
     * @param key L[
     * @param value ϊΏۂ̃IuWFNg
     */
    public ThrowableSimpleElement(Object key, Object value){
        super(key, value);
    }
    
    /**
     * ̗vfێǑƂȂO{@link #toString()}ŏo͂邩ǂݒ肷B<p>
     * ftHǵAtrueB
     *
     * @param output o͂ꍇtrue
     */
    public void setOutputCause(boolean output){
        isOutputCause = output;
    }
    
    /**
     * ̗vfێǑƂȂO{@link #toString()}ŏo͂邩ǂ𔻒肷B<p>
     *
     * @return truȅꍇo͂
     */
    public boolean getOutputCause() {
        return isOutputCause;
    }
    
    /**
     * X^bNg[X̏o͎Ƀ^uŃCfg邩ǂݒ肷B<p>
     * ftHǵAtrueB
     *
     * @param outputTab ^uŃCfgꍇ́Atrue
     */
    public void setOutputTab(boolean outputTab) {
        isOutputTab = outputTab;
    }
    
    /**
     * X^bNg[X̏o͎Ƀ^uŃCfg邩ǂ𔻒肷B<p>
     *
     * @return ^uŃCfgꍇ́Atrue
     */
    public boolean getOutputTab() {
        return isOutputTab;
    }
    
    /**
     * ̗ÕX^bNg[X⌴ƂȂÕX^bNg[XɂĎ擾B<p>
     * 
     * @return ̗ÕX^bNg[X⌴ƂȂÕX^bNg[X
     */
    public String toString(){
        if(value == null){
            return super.toString();
        }
        Throwable e = (Throwable)value;
        final StringBuilder buf = new StringBuilder();
        buf.append(MSG_TITLE).append(e).append(LINE_SEP);
        final StackTraceElement[] elemss = e.getStackTrace();
        if(elemss != null){
            for(int i = 0, max = elemss.length; i < max; i++){
                if(isOutputTab){
                    buf.append(TAB);
                }
                buf.append(elemss[i]);
                if(i != max - 1){
                    buf.append(LINE_SEP);
                }
            }
        }
        if(isOutputCause){
            for(Throwable ee = getCause(e); ee != null; ee = getCause(ee)){
                buf.append(LINE_SEP).append(MSG_CAUSE)
                    .append(ee).append(LINE_SEP);
                final StackTraceElement[] elems = ee.getStackTrace();
                if(elems != null){
                    for(int i = 0, max = elems.length; i < max; i++){
                        if(isOutputTab){
                            buf.append(TAB);
                        }
                        buf.append(elems[i]);
                        if(i != max - 1){
                            buf.append(LINE_SEP);
                        }
                    }
                }
            }
        }
        return convertString(buf.toString());
    }
    
    private Throwable getCause(Throwable th){
        Throwable cause = null;
        String thClassName = th.getClass().getName();
        if(thClassName.equals(SERVLET_EXCEPTION_NAME)){
            // OServletException̏ꍇ́A[ǧ擾
            try{
                cause = (Throwable)th.getClass()
                    .getMethod(GET_ROOT_CAUSE_METHOD).invoke(th);
            }catch(NoSuchMethodException e){
            }catch(IllegalAccessException e){
            }catch(InvocationTargetException e){
            }
        }else if(thClassName.equals(JMS_EXCEPTION_NAME)){
            // OJMSException̏ꍇ́ANO擾
            try{
                cause = (Exception)th.getClass()
                    .getMethod(GET_LINKED_EXCEPTION_METHOD).invoke(th);
            }catch(NoSuchMethodException e){
            }catch(IllegalAccessException e){
            }catch(InvocationTargetException e){
            }
        }else{
            cause = th.getCause();
        }
        return cause == th ? null : cause;
    }
    
    /**
     * ̗vf̃IuWFNĝ܂܎擾B<p>
     * {@link #getValue()}ƓlԂB<br>
     * 
     * @return ̗vf̃IuWFNg
     */
    public Object toObject(){
        return getValue();
    }
}
